#include <stdio.h>
#include <stdlib.h>
#include "structures.h"
#include "competence.h"

/*!
* \file competence.c
* \brief Fichier contenant le code des fonctions liees aux arbres de comptences.
*/

/*! Copie de la struct Competence pour travailler

typedef struct Competence{
    char nomComp[TAILLE_NOMS];
    char id[TAILLE_ID];
    unsigned int prix_competence;
    struct Competence *frere;
    struct Competence *enfant;
    struct Effet_Competence *effet;
    boolean connu;
}Competence;

*/

int taille(Competence *noeud)
{
    Competence *enfant;
    int compteur = 1;
    for (enfant = noeud->enfant; enfant != NULL; enfant = enfant->frere)
        compteur += taille(enfant);
    return compteur;
}

unsigned int hauteur(Competence *noeud)
{
    if (!estVide(noeud))
    {
        int compteur = 1;
        Competence *enfant;
        for (enfant = noeud->enfant; enfant != NULL; enfant = enfant->frere)
        {
            if (hauteur(enfant) > compteur)
            compteur = 1 + hauteur(enfant);
        }
        return compteur;
    }else{
        return 0;
    }
}

int estVide(Competence *c)
{
    if (c->enfant == NULL)
        return 0;
    else
        return 1;
}

boolean est_connue(Competence *c)
{
    return (c->connu);
}


unsigned int NbEnfants(Competence *noeud)
{
    unsigned int nb;
	if (estVide(noeud))
    {
        nb = 0;
    }
    else
    {
        Competence *enfant;
        for(noeud->enfant; enfant!= NULL; enfant=enfant->frere);

		nb++;
    }
    return nb;
}


/* -------------------------------------------------------------------------------------- */

Competence* construire_arbre_competence(Competence* a){
    return NULL;

}

int rafraichir_competences(Competence * a){
    return 0;
}




boolean est_complet(Competence *a){
    return 0;
}

int chemin_auto_competence(Competence* c){      /* Renvoie la liste des comptences non connues se trouvant sur le chemin d'une comptence slectionne */
    return 0;
}

Effet_Competence * get_effet(Competence *c){      /* Renvoie l'effet d'une competence */
    return c->effet;
}
